<?php 
/* 
Plugin Name: Google Wave Element
Plugin URI: http://www.dolcebita.com/wordpress/google-wave-element/
Description: Add the Wave Element to your blog so visitors can see and interact with the wave on your site.
Version: 0.1.1
Author: Marcos Esperon
Author URI: http://www.dolcebita.com/
*/

/*  Copyright 2010  Marcos Esperon

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; 
*/

$gwe_options['widget_fields']['wave'] = array('label'=>'Wave:', 'type'=>'text', 'default'=>'', 'class'=>'widefat', 'size'=>'', 'help'=>'');
$gwe_options['widget_fields']['width'] = array('label'=>'Width:', 'type'=>'text', 'default'=>'300', 'class'=>'', 'size'=>'3', 'help'=>'(Value in px)');
$gwe_options['widget_fields']['height'] = array('label'=>'Height:', 'type'=>'text', 'default'=>'500', 'class'=>'', 'size'=>'3', 'help'=>'(Value in px)');
$gwe_options['widget_fields']['header'] = array('label'=>'Header:', 'type'=>'checkbox', 'default'=>true, 'class'=>'', 'size'=>'', 'help'=>'');
$gwe_options['widget_fields']['toolbar'] = array('label'=>'Toolbar:', 'type'=>'checkbox', 'default'=>true, 'class'=>'', 'size'=>'', 'help'=>'');
$gwe_options['widget_fields']['footer'] = array('label'=>'Footer:', 'type'=>'checkbox', 'default'=>true, 'class'=>'', 'size'=>'', 'help'=>'');

function gwe_loadwave($wave, $width, $height, $header, $toolbar, $footer) {
  
  $output = '';
  
  if ($wave != '') {
  
    if(strrpos($wave, 'googlewave')) {
      $pattern = '/googlewave\.com![a-zA-Z0-9%\-_]+/i';
      preg_match($pattern, $url, $matches);
      $wave = $matches[0];
      $wave = str_replace('googlewave.com!w%252B', '', $id);
    } else {
      $wave = substr($wave, 0, 9);
    }
    
    $frame = 'waveframe-'.time();
    $width = ($width != '') ? $width : '500';
    $height = ($height != '') ? $height : '500';
    $header = ($header == '0') ? 'false' : 'true';
    $toolbar = ($toolbar == '0') ? 'false' : 'true';
    $footer = ($footer == '0') ? 'false' : 'true';
    
    $output = '<div id="'.$frame.'" style="width: '.$width.'px; height: '.$height.'px; overflow: hidden"></div>
               <script type="text/javascript" src="http://www.google.com/jsapi"></script>
               <script type="text/javascript">
               google.load("wave", "1");
               google.setOnLoadCallback(initialize);
               function initialize() {
                 var waveframe = document.getElementById("'.$frame.'");
                 var embedOptions = {
                   target: waveframe,
                   header: '.$header.',
                   toolbar: '.$toolbar.',
                   footer: '.$footer.'
                 };
                 var wavePanel = new google.wave.WavePanel(embedOptions);
                 wavePanel.loadWave("googlewave.com!w+'.$wave.'");
               }
               </script>';
             
  };
  
  return $output;
  
}

function google_wave_element($wave, $width, $height, $header, $toolbar, $footer) {
  echo gwe_loadwave($wave, $width, $height, $header, $toolbar, $footer);
}

function gwe_shortcode($attr) {  
  $wave = $attr[wave];
  if($wave != '') {
    $width = $attr[width];
    $height = $attr[height];
    $header = $attr[header];
    $toolbar = $attr[toolbar];
    $footer = $attr[footer];
    return gwe_loadwave($wave, $width, $height, $header, $toolbar, $footer);
  }
}

add_shortcode('gwe', 'gwe_shortcode');

function widget_gwe_init() {

	if ( !function_exists('register_sidebar_widget') )
		return;
	
	$check_options = get_option('widget_gwe');
  
	function widget_gwe($args) {

		global $gwe_options;
    
    // $args is an array of strings that help widgets to conform to
		// the active theme: before_widget, before_title, after_widget,
		// and after_title are the array keys. Default tags: li and h2.
    
		extract($args);
		
		$options = get_option('widget_gwe');
		
		// fill options with default values if value is not set
		$item = $options;
		foreach($gwe_options['widget_fields'] as $key => $field) {
			if (! isset($item[$key])) {
				$item[$key] = $field['default'];
			}
		}    
		    
    $wave = $item['wave'];
    $width = $item['width'];
    $height = $item['height'];
    $header = ($item['header']) ? 1 : 0;
    $toolbar = ($item['toolbar']) ? 1 : 0;
    $footer = ($item['footer']) ? 1 : 0;
    
		// These lines generate our output.
    echo $before_widget;// . $before_title . $title . $after_title;    
    google_wave_element($wave, $width, $height, $header, $toolbar, $footer);
    echo $after_widget;
				
	}

	// This is the function that outputs the form to let the users edit
	// the widget's title. It's an optional feature that users cry for.
	function widget_gwe_control() {
	
		global $gwe_options;

		// Get our options and see if we're handling a form submission.
		$options = get_option('widget_gwe');
		if ( isset($_POST['gwe-submit']) ) {

			foreach($gwe_options['widget_fields'] as $key => $field) {
				$options[$key] = $field['default'];
				$field_name = sprintf('%s', $key);        
				if ($field['type'] == 'text') {
					$options[$key] = strip_tags(stripslashes($_POST[$field_name]));
				} elseif ($field['type'] == 'checkbox') {
					$options[$key] = isset($_POST[$field_name]);
				}
			}

			update_option('widget_gwe', $options);
		}
    
		foreach($gwe_options['widget_fields'] as $key => $field) {
			$field_name = sprintf('%s', $key);
			$field_checked = '';
			if ($field['type'] == 'text') {
				$field_value = (isset($options[$key])) ? htmlspecialchars($options[$key], ENT_QUOTES) : htmlspecialchars($field['default'], ENT_QUOTES);
			} elseif ($field['type'] == 'checkbox') {
				$field_value = (isset($options[$key])) ? $options[$key] :$field['default'] ;
				if ($field_value == 1) {
					$field_checked = 'checked="checked"';
				}
			}
      $jump = ($field['type'] != 'checkbox') ? '<br />' : '&nbsp;';
      $field_class = $field['class'];
      $field_size = ($field['class'] != '') ? '' : 'size="'.$field['size'].'"';
      $field_help = ($field['help'] == '') ? '' : '<small>'.$field['help'].'</small>';
			printf('<p class="gwe_field"><label for="%s">%s</label>%s<input id="%s" name="%s" type="%s" value="%s" class="%s" %s %s /> %s</p>',
		  $field_name, __($field['label']), $jump, $field_name, $field_name, $field['type'], $field_value, $field_class, $field_size, $field_checked, $field_help);
		}

		echo '<input type="hidden" id="gwe-submit" name="gwe-submit" value="1" />';
	}	
	
	function widget_gwe_register() {		
    $title = 'Google Wave Element';
    // Register widget for use
    register_sidebar_widget($title, 'widget_gwe');    
    // Register settings for use, 300x100 pixel form
    register_widget_control($title, 'widget_gwe_control');
	}

	widget_gwe_register();
}

// Run our code later in case this loads prior to any required plugins.
add_action('widgets_init', 'widget_gwe_init');

?>